Compare commits

...

15 Commits

Author SHA1 Message Date
Asif Bacchus 276de6d890 style(script): reformat and fix typos
- reformat spacing, indentation
- fix spelling mistakes
- change textblock functions to camelCase
- add shellcheck exceptions
2021-05-15 10:09:15 -06:00
Asif Bacchus a4221ae6e4 refactor(script): used fixed export location
- previous random name made full restore virtually impossible
- use one container directory to make full restore easy
- store each backup in timestamped subdirectory for easy
incremental restore
2021-05-15 09:59:42 -06:00
Asif Bacchus f87a2356a5 chore: update readme, remove vscode dir 2021-05-15 09:50:56 -06:00
Asif Bacchus 75368e108b update licence and export prefs 2020-08-14 00:44:51 -06:00
Asif Bacchus d0e8eca1d6 add keyfile to details file 2020-08-14 00:43:47 -06:00
Asif Bacchus b6ce0fc673 add keyfile support 2020-08-14 00:42:00 -06:00
Asif Bacchus 6fc82aac83 cleanup printf formatting 2020-08-14 00:39:23 -06:00
Asif Bacchus 760399a0fd update scriptHelp 2020-08-14 00:20:49 -06:00
Asif Bacchus 868398858e add defaults text formatting function 2020-08-14 00:10:48 -06:00
Asif Bacchus 44e57df831 func trapExit: cleanup printf formatting 2020-08-14 00:03:32 -06:00
Asif Bacchus bbea5e871c add textblock formatting functions 2020-08-14 00:02:36 -06:00
Asif Bacchus e74971997f funcs cleanup, exitError: printf formatting 2020-08-14 00:00:09 -06:00
Asif Bacchus ffc7579666 func badParam: proper printf formatting 2020-08-13 23:53:51 -06:00
Asif Bacchus acec0d6b23 check for tput before setting formatting 2020-08-13 23:51:36 -06:00
Asif Bacchus 5b1678c6ae set term to dummy for cron, update path 2020-08-13 23:48:52 -06:00
11 changed files with 415 additions and 338 deletions
+1
View File
@@ -73,3 +73,4 @@
.gitattributes export-ignore
.gitignore export-ignore
.vscode export-ignore
+13
View File
@@ -0,0 +1,13 @@
# Default ignored files
/shelf/
/workspace.xml
# Rider ignored files
/modules.xml
/contentModel.xml
/.idea.pilerBackup.iml
/projectSettingsUpdater.xml
# Datasource local storage ignored files
/../../../../../../../../../:\Redirected\Asif\Documents\RiderProjects\pilerBackup\.idea\.idea.pilerBackup.dir\.idea/dataSources/
/dataSources.local.xml
# Editor-based HTTP Client requests
/httpRequests/
+6
View File
@@ -0,0 +1,6 @@
<?xml version="1.0" encoding="UTF-8"?>
<project version="4">
<component name="ProjectDictionaryState">
<dictionary name="asif" />
</component>
</project>
+8
View File
@@ -0,0 +1,8 @@
<?xml version="1.0" encoding="UTF-8"?>
<project version="4">
<component name="ContentModelUserStore">
<attachedFolders />
<explicitIncludes />
<explicitExcludes />
</component>
</project>
+7
View File
@@ -0,0 +1,7 @@
<?xml version="1.0" encoding="UTF-8"?>
<module type="RIDER_MODULE" version="4">
<component name="NewModuleRootManager">
<content url="file://$MODULE_DIR$/../.." />
<orderEntry type="sourceFolder" forTests="false" />
</component>
</module>
+13
View File
@@ -0,0 +1,13 @@
<?xml version="1.0" encoding="UTF-8"?>
<project version="4">
<component name="CommitMessageInspectionProfile">
<profile version="1.0">
<inspection_tool class="BodyLimit" enabled="true" level="ERROR" enabled_by_default="true" />
<inspection_tool class="SubjectBodySeparation" enabled="true" level="ERROR" enabled_by_default="true" />
<inspection_tool class="SubjectLimit" enabled="true" level="ERROR" enabled_by_default="true" />
</profile>
</component>
<component name="VcsDirectoryMappings">
<mapping directory="$PROJECT_DIR$" vcs="Git" />
</component>
</project>
-3
View File
@@ -1,3 +0,0 @@
{
"bookmarks": []
}
+1 -1
View File
@@ -1,6 +1,6 @@
MIT License
Copyright (c) 2019 Asif Bacchus
Copyright (c) 2019-2020 Asif Bacchus
Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
+1 -1
View File
@@ -1,3 +1,3 @@
# pilerBackup
Use pilerexport to output raw EML files and then back them up to rsync using borg
Use pilerexport to output raw EML files and then back them up using borgbackup.
+6
View File
@@ -32,6 +32,12 @@ borgConnectRepo="jdoe123@borg.server.net:pilerBackup/"
# recommended for security
borgRepoPassphrase="p@ssW0rd"
# keyfile to access repo
# FULL PATH where the associated keyfile for your repo is located -- relevant
# only if your repo requires a keyfile (i.e. 'keyfile' vs 'repokey') and if you
# are not using the default keyfile location
borgKeyfileLocation="/var/borgbackup/.config/borg/keys/server_address__repo_name"
# OPTIONAL: path to text file containing a list (one per line) of files/
# directories to include in your backup along with exported data from piler
# see repo wiki for more details
+227 -201
View File
@@ -4,21 +4,38 @@
### Backup exported email from piler (bare-metal)
#######
### set environment variables
if [ -z "$TERM" ]; then
export TERM=dumb
fi
export PATH=$PATH:/usr/local/bin
### text formatting presents
norm=$(tput sgr0)
err=$(tput bold)$(tput setaf 1)
warn=$(tput bold)$(tput setaf 3)
ok=$(tput setaf 2)
yellow=$(tput setaf 3)
if command -v tput >/dev/null; then
bold=$(tput bold)
cyan=$(tput setaf 6)
err=$(tput bold)$(tput setaf 1)
magenta=$(tput setaf 5)
norm=$(tput sgr0)
ok=$(tput setaf 2)
warn=$(tput bold)$(tput setaf 3)
width=$(tput cols)
yellow=$(tput setaf 3)
else
bold=""
cyan=""
err=""
magenta=""
norm=""
ok=""
warn=""
width=80
yellow=""
fi
### trap
trap trapExit 1 2 3 6
### functions
# bad configuration value passed in details file
@@ -33,20 +50,20 @@ badDetails () {
# bad parameter passed to script
badParam() {
if [ "$1" = "dne" ]; then
printf "${err}\nError: '%s %s'\n" "$2" "$3"
printf "file or directory does not exist.${norm}\n\n"
printf "\n%sError: '%s %s'\n" "$err" "$2" "$3"
printf "file or directory does not exist.%s\n\n" "$norm"
exit 1
elif [ "$1" = "empty" ]; then
printf "${err}\nError: '%s' cannot have a NULL (empty) value.\n" "$2"
printf "${cyan}Please use '--help' for assistance${norm}\n\n"
printf "\n%sError: '%s' cannot have a NULL (empty) value.\n" "$err" "$2"
printf "%sPlease use '--help' for assistance%s\n\n" "$cyan" "$norm"
exit 1
elif [ "$1" = "svc" ]; then
printf "${err}\nError: '%s %s': Service does not exist!${norm}\n\n" \
"$2" "$3"
printf "\n%sError: '%s %s': Service does not exist!${norm}\n\n" \
"$err" "$2" "$3"
exit 1
elif [ "$1" = "user" ]; then
printf "${err}\nError: '%s %s': User does not exist!${norm}\n\n" \
"$2" "$3"
printf "\n%sError: '%s %s': User does not exist!${norm}\n\n" \
"$err" "$2" "$3"
exit 1
fi
}
@@ -56,109 +73,99 @@ cleanup () {
# cleanup 503 if copied
if [ "$err503Copied" -eq 1 ]; then
if ! rm -f "$webroot/$err503File" 2>>"$logFile"; then
printf "${warn}[%s] -- [WARNING] Could not remove 503 error page." \
"$(stamp)" >> "$logFile"
# shellcheck disable=SC2129
printf "%s[%s] -- [WARNING] Could not remove 503 error page." \
"$warn" "$(stamp)" >>"$logFile"
printf " Web interface will not function until this file is " \
>>"$logFile"
printf "removed --${norm}\n" >> "$logFile"
printf "removed --%s\n" "$norm" >>"$logFile"
warnCount=$((warnCount + 1))
else
printf "${cyan}[%s] -- [INFO] 503 error page removed --${norm}\n" \
"$(stamp)" >> "$logFile"
printf "%s[%s] -- [INFO] 503 error page removed --%s\n" \
"$cyan" "$(stamp)" "$norm" >>"$logFile"
fi
fi
# remove EML temporary directory
if ! rm -rf "$exportDir" 2>>"$logFile"; then
printf "${warn}[%s] -- [WARNING] Could not remove EML export tmp dir:" \
"$(stamp)" >> "$logFile"
# shellcheck disable=SC2129
printf "%s[%s] -- [WARNING] Could not remove EML export tmp dir:" \
"$warn" "$(stamp)" >>"$logFile"
printf "\n%s\n" "$exportDir" >>"$logFile"
printf "please remove this directory manually! --${norm}\n" \
printf "please remove this directory manually! --%s\n" "$norm" \
>>"$logFile"
warnCount=$((warnCount + 1))
else
printf "${cyan}[%s] -- [INFO] EML temp directory removed --${norm}\n" \
"$(stamp)" >> "$logFile"
printf "%s[%s] -- [INFO] EML temp directory removed --%s\n" \
"$cyan" "$(stamp)" "$norm" >>"$logFile"
fi
}
# call cleanup and then exit with error report
exitError() {
printf "${err}[%s] -- [ERROR] %s: %s --${norm}\n" \
"$(stamp)" "$1" "$2" >> "$logFile"
printf "%s[%s] -- [ERROR] %s: %s --%s\n" \
"$err" "$(stamp)" "$1" "$2" "$norm" >>"$logFile"
cleanup
# note script completion with error
printf "${err}[%s] --- %s execution completed with error ---${norm}\n" \
"$(stamp)" "$scriptName" >> "$logFile"
printf "%s[%s] --- %s execution completed with error ---%s\n" \
"$err" "$(stamp)" "$scriptName" "$norm" >>"$logFile"
exit "$1"
}
# display script help information
scriptHelp() {
printf "\n${cyan}%s\n" "--------------------------------------------------------------------------------"
printf "Usage:${norm} %s [parameters]\n\n" "$scriptName"
printf "${cyan}Parameters ${yellow}(default value):${norm}\n"
printf "There are NO mandatory parameters. If a parameter is not "
printf "supplied, it's\n"
printf "default value will be used. In the case of a switch parameter, "
printf "it will\n"
printf "remain deactivated if not specified.\n\n"
printf "${magenta}script related\n"
printf "${cyan}-c, --config, --details${norm}\n"
printf "Path to the configuration key/value pair file for this script.\n"
printf "${yellow}(scriptPath/scriptName.details)${norm}\n\n"
printf "${cyan}-h, -?, --help${norm}\n"
printf "This help screen.\n\n"
printf "${cyan}-l, --log${norm}\n"
printf "Path to write log file.\n"
printf "${yellow}(scriptPath/scriptName.log)${norm}\n\n"
printf "${cyan}-v, --verbose${norm}\n"
printf "Log borg output with increased verbosity (list all files). "
printf "Careful! Your\n"
printf "log file can get large very quickly! This is a switch value, "
printf "specifying it\n"
printf "will turn the option ON.\n"
printf "${yellow}(normal output, option is OFF)${norm}\n\n"
printf "${magenta}export options\n"
printf "${cyan}-a, --all${norm}\n"
printf "Export ALL email saved by piler. This is generally only useful "
printf "for an initial\n"
printf "backup. This is a switch parameter and WILL override specified "
printf "start/end dates.\n"
printf "${yellow}(option is OFF, use start/end dates)${norm}\n\n"
printf "${cyan}--start${norm}\n"
printf "Export email starting from this date (inclusive)\n"
printf "Date MUST be provided in the format 'YYYY.MM.DD'\n"
printf "${yellow}(Yesterday's date)${norm}\n\n"
printf "${cyan}--end${norm}\n"
printf "Export email ending at this date (inclusive)\n"
printf "Date MUST be provided in the format 'YYYY.MM.DD'\n"
printf "${yellow}(Yesterday's date)${norm}\n\n"
printf "${magenta}503 functionality\n"
printf "${cyan}-5, --use-503${norm}\n"
printf "Copy an 'error 503' page to your webroot for your webserver to "
printf "find. This is a\n"
printf "switch value, specifying it will instruct the script to copy the "
printf "error page.\n"
printf "${yellow}(do NOT copy, option is OFF)${norm}\n\n"
printf "${cyan}--503-path${norm}\n"
printf "Path to the file you want copied to your webroot as the 'error "
printf "503' page during\n"
printf "backup operations.\n"
printf "${yellow}(scriptPath/503_backup.html)${norm}\n\n"
printf "${cyan}-w, --webroot${norm}\n"
printf "Path to where the 'error 503' file should be copied during "
printf "backups.\n"
printf "${yellow}(/usr/share/nginx/html)${norm}\n\n"
printf "More details and examples of script usage can be found in the "
printf "repo wiki at\n"
printf "${yellow}https://git.asifbacchus.app/asif/pilerBackup/wiki${norm}\n"
printf "${cyan}%s${norm}\n\n" "--------------------------------------------------------------------------------"
newline
printf "%sUsage: %s [parameters]%s\n\n" "$bold" "$scriptName" "$norm"
textBlock "There are no mandatory parameters. If a parameter is not supplied, its default value will be used. In the case of a switch parameter, it will remain DEACTIVATED by default."
newline
textBlock "Parameters are listed then followed by a description of their effect on the following line. Finally, if a default value exists, it will be listed on the next line in (parentheses)."
newline
textBlock "${magenta}--- script related ---${norm}"
newline
textBlockSwitch "-c | --config | --details"
textBlock "Path to the configuration key/value pair file for this script."
textBlockDefaults "(scriptPath/scriptName.details)"
newline
textBlockSwitch "-h | -? | --help"
textBlock "This help screen."
newline
textBlockSwitch "-l | --log"
textBlock "Path to write log file."
textBlockDefaults "(scriptPath/scriptName.log)"
newline
textBlockSwitch "[SWITCH] -v | --verbose"
textBlock "Log borg output with increased verbosity (list all files). Careful! Your log file can get very large very quickly!"
textBlockDefaults "(normal output, option is OFF)"
newline
textBlock "${magenta}--- export options ---${norm}"
newline
textBlockSwitch "[SWITCH] -a | --all"
textBlock "Export ALL email saved by piler. This is generally only useful for an initial backup. Setting this switch will override any specified start/end dates."
textBlockDefaults "(use start/end dates, option is OFF)"
newline
textBlockSwitch "--start"
textBlock "Export email starting from this date (inclusive). Date MUST be provided in YYYY.MM.DD format."
textBlockDefaults "(yesterday's date)"
newline
textBlockSwitch "--end"
textBlock "Export email ending at this date (inclusive). Date MUST be provided in YYYY.MM.DD format."
textBlockDefaults "(yesterday's date)"
newline
textBlock "${magenta}--- 503 functionality ---${norm}"
newline
textBlockSwitch "[SWITCH] -5 | --use-503"
textBlock "Copy an 'error 503' page/indicator file to your webroot for your webserver to find. Specifying this option will enable other 503 options."
textBlockDefaults "(do NOT copy, option is OFF)"
newline
textBlockSwitch "--503-path"
textBlock "Path to the file you want copied to your webroot as the 'error 503' page."
textBlockDefaults "(scriptPath/503_backup.html)"
newline
textBlockSwitch "-w | --webroot"
textBlock "Path to where the 'error 503' file should be copied."
textBlockDefaults "(/usr/share/nginx/html/)"
newline
textBlock "More details and examples of script usage can be found in the repo wiki at ${yellow}https://git.asifbacchus.app/asif/pilerBackup/wiki${norm}"
newline
}
# generate dynamic timestamps
@@ -166,20 +173,35 @@ stamp () {
(date +%F" "%T)
}
textBlock() {
printf "%s\n" "$1" | fold -w "$width" -s
}
textBlockDefaults() {
printf "%s%s%s\n" "$yellow" "$1" "$norm"
}
textBlockSwitch() {
printf "%s%s%s\n" "$cyan" "$1" "$norm"
}
newline() {
printf "\n"
}
# same as exitError but for signal captures
trapExit() {
printf "${err}[%s] -- [ERROR] 99: Caught signal --${norm}\n" \
"$(stamp)" >> "$logFile"
printf "%s[%s] -- [ERROR] 99: Caught signal --%s\n" \
"$err" "$(stamp)" "$norm" >>"$logFile"
cleanup
# note script completion with error
printf "${err}[%s] --- %s execution was terminated via signal ---${norm}\n" \
"$(stamp)" "$scriptName" >> "$logFile"
printf "%s[%s] --- %s execution was terminated via signal ---%s\n" \
"$err" "$(stamp)" "$scriptName" "$norm" >>"$logFile"
exit 99
}
### end of functions
### default variable values
## script related
@@ -209,7 +231,6 @@ exportStart=$( date -d 'yesterday' +'%Y.%m.%d' )
exportEnd=$(date -d 'yesterday' +'%Y.%m.%d')
pilerUser='piler'
### process startup parameters
while [ $# -gt 0 ]; do
case "$1" in
@@ -312,25 +333,24 @@ while [ $# -gt 0 ]; do
fi
;;
*)
printf "${err}\nUnknown option: %s\n" "$1"
printf "${cyan}Use '--help' for valid options.{$norm}\n\n"
printf "%s\nUnknown option: %s\n" "$err" "$1"
printf "%sUse '--help' for valid options.%s\n\n" "$cyan" "$norm"
exit 1
;;
esac
shift
done
### check pre-requisites and default values
# check if running as root, otherwise exit
if [ $( id -u ) -ne 0 ]; then
printf "\n${err}ERROR: script MUST be run as ROOT${norm}\n\n"
if [ "$(id -u)" -ne 0 ]; then
printf "\n%sERROR: script MUST be run as ROOT%s\n\n" "$err" "$norm"
exit 2
fi
# find pilerexport, otherwise this is all pointless
pilerExport=$(command -v pilerexport)
if [ ! "$pilerExport" ]; then
printf "\n${err}ERROR: cannot find 'pilerexport'${norm}\n\n"
printf "\n%sERROR: cannot find 'pilerexport'%s\n\n" "$err" "$norm"
exit 4
fi
# does the details file exist?
@@ -339,7 +359,7 @@ if [ ! -f "$configDetails" ]; then
fi
# is borg installed?
if ! command -v borg >/dev/null; then
printf "\n${err}ERROR: BORG is not installed on this system!${norm}\n\n"
printf "\n%sERROR: BORG is not installed on this system!%s\n\n" "$err" "$norm"
exit 3
fi
# if 503 functionality is enabled, do 503 related files exist?
@@ -351,92 +371,91 @@ if [ "$use503" -eq 1 ]; then
fi
fi
### start logging
printf "${magenta}[%s] --- Start %s execution ---${norm}\n" \
"$(stamp)" "$scriptName" >> "$logFile"
printf "${cyan}[%s] -- [INFO] Log located at ${yellow}%s${cyan} --${norm}\n" \
"$(stamp)" "$logFile" >> "$logFile"
printf "%s[%s] --- Start %s execution ---%s\n" \
"$magenta" "$(stamp)" "$scriptName" "$norm" >>"$logFile"
printf "%s[%s] -- [INFO] Log located at %s%s%s --%s\n" \
"$cyan" "$(stamp)" "$yellow" "$logFile" "$cyan" "$norm" >>"$logFile"
### 503 functionality
if [ "$use503" -eq 1 ]; then
printf "${cyan}[%s] -- [INFO] Copying 503 error page to " \
"$(stamp)" >> "$logFile"
printf "webroot -- ${norm}\n" >> "$logFile"
if ! \cp --force "${err503Path}" "${webroot}/${err503File}" 2>> "$logFile"
then
printf "${warn}[%s] -- [WARNING] Failed to copy 503 error page. " \
"$(stamp)" >> "$logFile"
printf "Web users will NOT be notified --${norm}\n" >> "$logFile"
printf "%s[%s] -- [INFO] Copying 503 error page to " \
"$cyan" "$(stamp)" >>"$logFile"
printf "webroot -- %s\n" "$norm" >>"$logFile"
if ! \cp --force "${err503Path}" "${webroot}/${err503File}" 2>>"$logFile"; then
printf "%s[%s] -- [WARNING] Failed to copy 503 error page. " \
"$warn" "$(stamp)" >>"$logFile"
printf "Web users will NOT be notified --%s\n" "$norm" >>"$logFile"
warnCount=$((warnCount + 1))
else
printf "${ok}[%s] -- [SUCCESS] 503 error page copied --${norm}\n" \
"$(stamp)" >> "$logFile"
printf "%s[%s] -- [SUCCESS] 503 error page copied --%s\n" \
"$ok" "$(stamp)" "$norm" >>"$logFile"
# set cleanup flag
err503Copied=1
fi
fi
### read details file to get variables needed to dump sql and run borg
# check if config details file was provided as a relative or absolute path
case "${configDetails}" in
/*)
# absolute path, no need to rewrite variable
# shellcheck source=pilerbackup.details
. "${configDetails}"
;;
*)
# relative path, prepend './' to create absolute path
# shellcheck source=pilerbackup.details
. "./${configDetails}"
;;
esac
printf "${cyan}[%s] -- [INFO] ${yellow}%s${cyan} imported --${norm}\n" \
"$(stamp)" "$configDetails" >> "$logFile"
printf "%s[%s] -- [INFO] %s%s%s imported --%s\n" \
"$cyan" "$(stamp)" "$yellow" "$configDetails" "$cyan" "$norm" >>"$logFile"
## create tmp directory and change to it for export operations
# create temporary directory to dump exported email from piler
if ! exportDir=$( mktemp -d 2>>"$logFile" ); then
tmpdir="/tmp/emailbackup/$(date +%F_%T)"
if ! exportDir=$(mkdir -p "${tmpdir}" 2>>"$logFile"); then
exitError 111 "Could not create temporary directory for exported EML files"
fi
# grant pilerUser permission to write to temporary directory
if ! (chown root:${pilerUser} "$exportDir" && chmod 770 "$exportDir"); then
if # shellcheck disable=SC2086
! (chown root:${pilerUser} "$exportDir" && chmod 770 "$exportDir")
then
exitError 112 "Could not set permissions on temporary directory"
fi
if ! cd "$exportDir"; then
exitError 113 "Unable to change to temporary export directory"
fi
printf "${cyan}[%s] -- [INFO] EML files will be temporarily stored in:" \
"$(stamp)" >> "$logFile"
printf "\n${yellow}%s/${cyan} --${norm}\n" "$exportDir" >> "$logFile"
# shellcheck disable=SC2129
printf "%s[%s] -- [INFO] EML files will be temporarily stored in:" \
"$cyan" "$(stamp)" >>"$logFile"
printf "\n\t%s%s/%s --%s\n" "$yellow" "$exportDir" "$cyan" "$norm" >>"$logFile"
## export EML from piler
printf "${cyan}[%s] -- [INFO] Exporting EML files from piler --${norm}\n" \
"$(stamp)" >> "$logFile"
printf "%s[%s] -- [INFO] Exporting EML files from piler --%s\n" \
"$cyan" "$(stamp)" "$norm" >>"$logFile"
if [ "$exportAll" -eq 1 ]; then
if ! ${pilerExport} -A 2>>"$logFile"; then
exitError 115 "There was a problem while exporting EML from piler"
fi
printf "${ok}[%s] -- [SUCCESS] Exported EML files from piler --${norm}\n" \
"$(stamp)" >> "$logFile"
printf "%s[%s] -- [SUCCESS] Exported EML files from piler --%s\n" \
"$ok" "$(stamp)" "$norm" >>"$logFile"
else
if ! ${pilerExport} -a "$exportStart" -b "$exportEnd" 2>>"$logFile"; then
exitError 115 "There was a problem while exporting EML from piler"
fi
printf "${ok}[%s] -- [SUCCESS] Exported EML files from piler --${norm}\n" \
"$(stamp)" >> "$logFile"
printf "%s[%s] -- [SUCCESS] Exported EML files from piler --%s\n" \
"$ok" "$(stamp)" "$norm" >>"$logFile"
fi
### pre-backup tasks completed -- move to borg tasks
printf "${ok}[%s] -- [SUCCESS] Pre-backup tasks completed --${norm}\n" \
"$(stamp)" >> "$logFile"
printf "%s[%s] -- [SUCCESS] Pre-backup tasks completed --%s\n" \
"$ok" "$(stamp)" "$norm" >>"$logFile"
### Run borg variable checks
printf "${cyan}[%s] -- [INFO] Verifying supplied borg details --${norm}\n" \
"$(stamp)" >> "$logFile"
printf "%s[%s] -- [INFO] Verifying supplied borg details --%s\n" \
"$cyan" "$(stamp)" "$norm" >>"$logFile"
## verify borg base directory
if [ -z "${borgBaseDir}" ]; then
@@ -444,8 +463,8 @@ if [ -z "${borgBaseDir}" ]; then
elif [ ! -d "${borgBaseDir}" ]; then
badDetails dne 'borgBaseDir'
fi
printf "${magenta}details:borgBaseDir ${norm}-- ${ok}[OK]${norm}\n" \
>> "$logFile"
printf "%sdetails:borgBaseDir%s -- %s[OK]%s\n" \
"$magenta" "$norm" "$ok" "$norm" >>"$logFile"
export BORG_BASE_DIR="${borgBaseDir%/}"
## check path to SSH keyfile
@@ -454,34 +473,46 @@ if [ -z "${borgSSHKey}" ]; then
elif [ ! -f "${borgSSHKey}" ]; then
badDetails dne 'borgSSHKey'
fi
printf "${magenta}details:borgSSHKey ${norm}-- ${ok}[OK]${norm}\n" \
>> "$logFile"
printf "%sdetails:borgSSHKey%s -- %s[OK]%s\n" \
"$magenta" "$norm" "$ok" "$norm" >>"$logFile"
export BORG_RSH="ssh -i ${borgSSHKey}"
## check borg repo connect string
if [ -z "${borgConnectRepo}" ]; then
badDetails empty 'borgConnectRepo'
fi
printf "${magenta}details:borgConnectRepo ${norm}-- ${ok}[OK]${norm}\n" \
>> "$logFile"
printf "%sdetails:borgConnectRepo%s -- %s[OK]%s\n" \
"$magenta" "$norm" "$ok" "$norm" >>"$logFile"
export BORG_REPO="${borgConnectRepo}"
## check borg repo password
if [ -n "${borgRepoPassphrase}" ]; then
printf "${magenta}details:borgRepoPassphrase ${norm}-- ${ok}[OK]${norm}\n" \
>> "$logFile"
printf "%sdetails:borgRepoPassphrase%s -- %s[OK]%s\n" \
"$magenta" "$norm" "$ok" "$norm" >>"$logFile"
export BORG_PASSPHRASE="${borgRepoPassphrase}"
else
# if passwd is blank intentionally, this is insecure
printf "${warn} -- [WARNING] Using a borg repo without a password is an " \
>> "$logFile"
printf "insecure configuration --${norm}\n" >> "$logFile"
printf "%s-- [WARNING] Using a borg repo without a password is an " \
"$warn" >>"$logFile"
printf "insecure configuration --%s\n" "$norm" >>"$logFile"
warnCount=$((warnCount + 1))
# if this was an accident, we need to provide a bogus passwd so borg fails
# otherwise it will sit forever just waiting for input
export BORG_PASSPHRASE="DummyPasswordSoBorgFails"
fi
## check borg repository keyfile location
if [ -z "${borgKeyfileLocation}" ]; then
printf "%sdetails:borgKeyfileLocation %s-- %s[DEFAULT]%s\n" "$magenta" "$norm" "$ok" "$norm" >>"$logFile"
else
# check if keyfile location exists
if [ ! -f "${borgKeyfileLocation}" ]; then
badDetails dne 'borgKeyfileLocation'
fi
printf "%sdetails:borgKeyfileLocation %s-- %s[OK]%s\n" "$magenta" "$norm" "$ok" "$norm" >>"$logFile"
export BORG_KEY_FILE="${borgKeyfileLocation}"
fi
## export borg remote path, if specified
if [ -n "${borgRemote}" ]; then export BORG_REMOTE_PATH="${borgRemote}"; fi
@@ -501,12 +532,12 @@ if [ -n "${borgXtraListPath}" ]; then
done <<EOF
$(sed -e '/^\s*#.*$/d' -e '/^\s*$/d' "${borgXtraListPath}")
EOF
printf "${magenta}details:borgXtraListPath ${norm}-- ${ok}[OK]${norm}\n" \
>> "$logFile"
printf "%sdetails:borgXtraListPath%s -- %s[OK]%s\n" \
"$magenta" "$norm" "$ok" "$norm" >>"$logFile"
includeXtra=1
fi
## check if exlusion list file is specified
## check if exclusion list file is specified
if [ -n "${borgExcludeListPath}" ]; then
# check if the file actually exists
if [ ! -f "${borgExcludeListPath}" ]; then
@@ -515,7 +546,6 @@ if [ -n "${borgExcludeListPath}" ]; then
exclusions=1
fi
### create borg temp dir:
## python requires a writable temporary directory when unpacking borg and
## executing commands. This defaults to /tmp but many systems mount /tmp with
@@ -527,14 +557,13 @@ if [ ! -d "${borgBaseDir}/tmp" ]; then
if ! mkdir "${borgBaseDir}/tmp"; then
exitError 132 "Unable to create borg ${borgBaseDir}/tmp directory"
else
printf "${cyan}[%s] -- [INFO] Created ${yellow}%s/tmp " \
"$(stamp)" "${borgBaseDir}" >> "$logFile"
printf "${cyan}--${norm}\n" >> "$logFile"
printf "%s[%s] -- [INFO] Created %s%s/tmp " \
"$cyan" "$(stamp)" "$yellow" "${borgBaseDir}" >>"$logFile"
printf "%s--%s\n" "$cyan" "$norm" >>"$logFile"
fi
fi
export TMPDIR="${borgBaseDir}/tmp"
### execute borg depending on whether extra files and/or exclusions are defined
## construct the proper borg commandline
@@ -556,94 +585,91 @@ if [ "$includeXtra" -eq 1 ]; then
fi
# execute borg
printf "${cyan}[%s] -- [INFO] Executing borg backup operation --${norm}\n" \
"$(stamp)" >> "$logFile"
printf "%s[%s] -- [INFO] Executing borg backup operation --%s\n" \
"$cyan" "$(stamp)" "$norm" >>"$logFile"
${borgCMD} 2>>"$logFile"
borgResult="$?"
## check borg exit status
if [ "$borgResult" -eq 0 ]; then
printf "${ok}[%s] -- [SUCCESS] Borg backup completed --${norm}\n" \
"$(stamp)" >> "$logFile"
printf "%s[%s] -- [SUCCESS] Borg backup completed --%s\n" \
"$ok" "$(stamp)" "$norm" >>"$logFile"
elif [ "$borgResult" -eq 1 ]; then
printf "${warn}[%s] -- [WARNING] Borg completed with warnings. " \
"$(stamp)" >> "$logFile"
printf "Review this logfile for details --${norm}\n" >> "$logFile"
printf "%s[%s] -- [WARNING] Borg completed with warnings. " \
"$warn" "$(stamp)" >>"$logFile"
printf "Review this logfile for details --%s\n" "$norm" >>"$logFile"
warnCount=$((warnCount + 1))
elif [ "$borgResult" -ge 2 ]; then
err_1="Borg exited with a critical error. Please review this log file"
err_2="for details."
exitError 138 "$err_1 $err_2"
else
printf "${warn}[%s] -- [WARNING] Borg exited with unknown return code. " \
"$(stamp)" >> "$logFile"
printf "Review this logfile for details --${norm}\n" >> "$logFile"
printf "%s[%s] -- [WARNING] Borg exited with unknown return code. " \
"$warn" "$(stamp)" >>"$logFile"
printf "Review this logfile for details --%s\n" "$norm" >>"$logFile"
warnCount=$((warnCount + 1))
fi
### execute borg prune if paramters are provided, otherwise skip with a warning
### execute borg prune if parameters are provided, otherwise skip with a warning
if [ -n "${borgPruneSettings}" ]; then
printf "${cyan}[%s] -- [INFO] Executing borg prune operation --${norm}\n" \
"$(stamp)" >> "$logFile"
printf "%s[%s] -- [INFO] Executing borg prune operation --%s\n" \
"$cyan" "$(stamp)" "$norm" >>"$logFile"
# shellcheck disable=SC2086
borg prune --show-rc -v ${borgPruneParams} ${borgPruneSettings} \
2>>"$logFile"
borgPruneResult="$?"
else
printf "${warn}[%s] -- [WARNING] No prune parameters provided. " \
"$(stamp)" >> "$logFile"
printf "Your archive will continue growing with each backup --${norm}\n" \
>> "$logFile"
printf "%s[%s] -- [WARNING] No prune parameters provided. " \
"$warn" "$(stamp)" >>"$logFile"
printf "Your archive will continue growing with each backup --%s\n" \
"$norm" >>"$logFile"
warnCount=$((warnCount + 1))
fi
## report on prune operation if executed
if [ -n "${borgPruneResult}" ]; then
if [ "${borgPruneResult}" -eq 0 ]; then
printf "${ok}[%s] -- [SUCCESS] Borg prune completed --${norm}\n" \
"$(stamp)" >> "$logFile"
printf "%s[%s] -- [SUCCESS] Borg prune completed --%s\n" \
"$ok" "$(stamp)" "$norm" >>"$logFile"
elif [ "$borgPruneResult" -eq 1 ]; then
printf "${warn}[%s] -- [WARNING] Borg prune completed with warnings. " \
"$(stamp)" >> "$logFile"
printf "Review this logfile for details --${norm}\n" >> "$logFile"
printf "%s[%s] -- [WARNING] Borg prune completed with warnings. " \
"$warn" "$(stamp)" >>"$logFile"
printf "Review this logfile for details --%s\n" "$norm" >>"$logFile"
warnCount=$((warnCount + 1))
elif [ "$borgPruneResult" -ge 2 ]; then
err_1="Borg prune exited with a critical error. Please review this"
err_2="log file for details."
exitError 139 "$err_1 $err_2"
else
printf "${warn}[%s] -- [WARNING] Borg prune exited with an unknown " \
"$(stamp)" >> "$logFile"
printf "return code. Review this logfile for details --${norm}\n" \
>> "$logFile"
printf "%s[%s] -- [WARNING] Borg prune exited with an unknown " \
"$warn" "$(stamp)" >>"$logFile"
printf "return code. Review this logfile for details --%s\n" \
"$norm" >>"$logFile"
warnCount=$((warnCount + 1))
fi
fi
### all processes successfully completed, cleanup and exit gracefully
# note successful completion of borg commands
printf "${ok}[%s] -- [SUCCESS] Backup operations completed --${norm}\n" \
"$(stamp)" >> "$logFile"
printf "%s[%s] -- [SUCCESS] Backup operations completed --%s\n" \
"$ok" "$(stamp)" "$norm" >>"$logFile"
# cleanup
cleanup
# note complete success, tally warnings and exit
printf "${ok}[%s] -- [SUCCESS] All processes completed --${norm}\n" \
"$(stamp)" >> "$logFile"
printf "${magenta}[%s] --- %s execution completed ---${norm}\n" \
"$(stamp)" "$scriptName" >> "$logFile"
printf "%s[%s] -- [SUCCESS] All processes completed --%s\n" \
"$ok" "$(stamp)" "$norm" >>"$logFile"
printf "%s[%s] --- %s execution completed ---%s\n" \
"$magenta" "$(stamp)" "$scriptName" "$norm" >>"$logFile"
if [ "$warnCount" -gt 0 ]; then
printf "${warn}%s warnings issued!${norm}\n" "${warnCount}" >> "$logFile"
printf "%s%s warnings issued!%s\n" "$warn" "${warnCount}" "$norm" >>"$logFile"
else
printf "${ok}0 warnings issued.${norm}\n" >> "$logFile"
printf "%s0 warnings issued.%s\n" "$ok" "$norm" >>"$logFile"
fi
exit 0
### error codes
# 1: parameter error
# 2: not run as root